function sim=sim_data(sol,shocks);

nb=size(sol.mx,1);
nf=size(sol.fx,1);
ny=size(sol.px,1);
nz=size(sol.phi,1);
ne=size(sol.me,2);
long=size(shocks,2);
M=[[sol.mx sol.mz];[zeros(nz,nb) sol.phi]];
P=[sol.px sol.pz;sol.fx sol.fz];
S=zeros(nb+nz,long);
R=[zeros(nb,ne);sol.me];
S(:,1)=R*shocks(:,1);
for t=2:long;
    S(:,t)=M*S(:,t-1)+R*shocks(:,t);
end
Y=P*S;

sim.x=S(1:nb,:)';
sim.z=S(nb+1:nb+nz,:)';
sim.y=Y(1:ny,:)';
sim.f=Y(ny+1:ny+nf,:)';
