function irf=comp_irf(sol,init,nrep);

nb=size(sol.mx,1);
nf=size(sol.fx,1);
ny=size(sol.px,1);
nz=size(sol.phi,1);
ne=size(sol.me,2);

M=[[sol.mx sol.mz];[zeros(nz,nb) sol.phi]];
P=[sol.px sol.pz;sol.fx sol.fz];
S=zeros(nb+nz,nrep);

S(:,1)=[zeros(nb,ne);sol.me]*init;
for t=2:nrep;
    S(:,t)=M*S(:,t-1);
end
Y=P*S;

irf.x=S(1:nb,:)';
irf.z=S(nb+1:nb+nz,:)';
irf.y=Y(1:ny,:)';
irf.f=Y(ny+1:ny+nf,:)';
